Beauty = LibStub("AceAddon-3.0"):NewAddon("Beauty", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Beauty")

local options = { 
    name = "Beauty",
    handler = Beauty,
    type = "group",
    args = {
	Extreme = {
		type = "execute",
		name = L["Extreme"],
		func = "setextreme",
		desc = L["Sets video settings to extreme"],
	},
	Low = {
		type = "execute",
		name = L["Low"],
		func = "setlow",
		desc = L["Sets video settings to low"],
	},
	Default = {
		type = "execute",
		name = L["Default"],
		func = "setdefault",
		desc = L["Sets video settings to normal"],
	},
	StartExtreme = {
		type = "toggle",
		name = L["Startup extreme"],
		desc = L["Loads extreme video settings on startup"],
		get = "IsExtremeStartup",
		set = "ToggleExtremeStartup",
	},
	Reset = {
		type = "execute",
		name = L["Reset defaults"],
		desc = L["Resets the default setting to your current setting."],
		func = "getvalue",
		confirm = true,
	},
    },
}


function Beauty:IsExtremeStartup(info)
	return self.db.profile.extremestartup
end

function Beauty:ToggleExtremeStartup(info, value)
	self.db.profile.extremestartup = value
end
	

function Beauty:setdefault()
	SetCVar("groundEffectDensity", self.db.profile.gdens);
	SetCVar("groundEffectDist", self.db.profile.gdist);
	SetCVar("horizonfarclip", self.db.profile.hfarclip);
	SetCVar("farclip", self.db.profile.farclip);
	SetCVar("smallcull", self.db.profile.smallcull);
	SetCVar("skycloudlod", self.db.profile.scl);
	ConsoleExec("detailDoodadAlpha 50");
	ConsoleExec("characterAmbient");
	DEFAULT_CHAT_FRAME:AddMessage(L["Beauty: Video settings set to default!"])
end

function Beauty:setlow()
	SetCVar("groundEffectDensity", 16);
	SetCVar("groundEffectDist", 1);
	SetCVar("horizonfarclip", 1305);
	SetCVar("farclip", 177);
	SetCVar("smallcull", 1);
	SetCVar("skycloudlod", 1);
	ConsoleExec("detailDoodadAlpha 1");
	DEFAULT_CHAT_FRAME:AddMessage(L["Beauty: Video settings set to low!"])
end


function Beauty:setextreme()
	SetCVar("farclip", 777);
	SetCVar("horizonfarclip", 6226);
	SetCVar("groundeffectdensity", 256);
	SetCVar("groundeffectdist", 140);
	SetCVar("smallcull", 0);
	SetCVar("skycloudlod", 3);
	ConsoleExec("detailDoodadAlpha 100");
	ConsoleExec("characterAmbient 0");
	DEFAULT_CHAT_FRAME:AddMessage(L["Beauty: Video settings set to extreme!"])
end

function Beauty:getvalue()
	self.db.profile.farclip=GetCVar('farclip');
	self.db.profile.hfarclip=GetCVar('horizonfarclip');
	self.db.profile.gdens=GetCVar("groundeffectdensity");
	self.db.profile.gdist=GetCVar("groundeffectdist");
	self.db.profile.smallcull=GetCVar ("smallcull");
	self.db.profile.scl=GetCVar("skycloudlod");
	DEFAULT_CHAT_FRAME:AddMessage(L["Beauty: Default settings reset!"])
end

function Beauty:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("BeautyDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Beauty", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Beauty", "Beauty")
	self:RegisterChatCommand("beauty", function(input)
	if(input == L["extreme"]) then
		self:setextreme()
	elseif (input == "menu") then
		InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
	elseif( input == L["low"]) then
		self:setlow()
	elseif(input == L["default"]) then		
		self:setdefault()
	elseif(input == "reset") then		
		self:getvalue()
	else DEFAULT_CHAT_FRAME:AddMessage(L["Beauty slash commands"])
		DEFAULT_CHAT_FRAME:AddMessage(L["Use - extreme/default/low to adjust video quality"])
		DEFAULT_CHAT_FRAME:AddMessage(L["- menu opens the options menu for Beauty"])
		DEFAULT_CHAT_FRAME:AddMessage(L["- reset to reset default settings to current settings"])
end
end)
end


--function Beauty:ChatCommand(input)
--	if not input or input:trim() == "" then
--       InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
--    else
       -- LibStub("AceConfigCmd-3.0").HandleCommand(Beauty, "Beauty", input)
--    end
--end


function Beauty:OnEnable()
    -- Called when the addon is enabled
	if (self.db.profile.firststart ~=1)  then
	self:getvalue();
	self.db.profile.extremestartup = 1;
	self.db.profile.firststart = 1;
	end
	if self.db.profile.extremestartup then
	self:setextreme();
	end
end

function Beauty:OnDisable()
    -- Called when the addon is disabled
	self:setdefault();
end
